
;------------------------------------------------------------------------
; MASTER WRITE SLOT
; BIT = CARRY
;------------------------------------------------------------------------

DS1820_2_WRBIT
	BCF INTCON,GIE
	; set time
	MOVLW 18	; typ 90 us
	MOVWF DS1820_2_HELP
	; set low
	BCF DS1820_2_IO
	BCF DS1820_2_DIR
	NOP
	NOP
	NOP
	; set output carry dependend
	BTFSC STATUS,CARRY
	BSF DS1820_2_DIR

DS1820_2_WRBIT_1
	; wait
	DECFSZ DS1820_2_HELP,F
	GOTO DS1820_2_WRBIT_1

	; high
	BSF DS1820_2_DIR
	BSF INTCON,GIE

	RETURN
;------------------------------------------------------------------------
; MASTER READ SLOT
; RESULT = CARRY
;------------------------------------------------------------------------

DS1820_2_RDBIT
	BCF INTCON,GIE
	; set time
	MOVLW 2 ; typ 15 us
	MOVWF DS1820_2_HELP
	; set low
	BCF DS1820_2_IO
	BCF DS1820_2_DIR
	NOP
	NOP
	NOP
	NOP
	; set high
	BSF DS1820_2_DIR

DS1820_2_RDBIT_1
	; wait short
	DECFSZ DS1820_2_HELP,F
	GOTO DS1820_2_RDBIT_1

	; set carry (read)
	BCF STATUS,CARRY
	BTFSC DS1820_2_IO
	BSF STATUS,CARRY

	; wait long
	MOVLW 9 ; typ 45 us
	MOVWF DS1820_2_HELP
DS1820_2_RDBIT_2
	DECFSZ DS1820_2_HELP,F
	GOTO DS1820_2_RDBIT_2

	BSF INTCON,GIE
	RETURN

;------------------------------------------------------------------------
; MASTER WRITE BYTE
;------------------------------------------------------------------------

DS1820_2_WRITE
	; store value
	MOVWF DS1820_2_HELP_1
	; 8 rounds
	BSF DS1820_2_HELP_2,3

DS1820_2_WB_1
	RRF DS1820_2_HELP_1,F
	CALL DS1820_2_WRBIT

	DECFSZ DS1820_2_HELP_2,F
	GOTO DS1820_2_WB_1
	RETURN

;------------------------------------------------------------------------
; MASTER READ BYTE
;------------------------------------------------------------------------

DS1820_2_READ
	; 8 rounds
	BSF DS1820_2_HELP_2,3

DS1820_2_RB_1
	; read
	CALL DS1820_2_RDBIT

	RRF DS1820_2_HELP_1,F

	DECFSZ DS1820_2_HELP_2,F
	GOTO DS1820_2_RB_1
	MOVF DS1820_2_HELP_1,W
	RETURN

;------------------------------------------------------------------------
; MASTER RESET AND CHECK PRESENCE
;------------------------------------------------------------------------

DS1820_2_RESET
	; set time
	MOVLW 100 ; typ 480 us
	MOVWF DS1820_2_HELP
	; set low
	BCF DS1820_2_IO
	BCF DS1820_2_DIR
DS1820_2_RESET_1
	; wait
	DECFSZ DS1820_2_HELP,F
	GOTO DS1820_2_RESET_1

	; set high
	BSF DS1820_2_DIR

	; check presence
	MOVLW 100 ; typ 480 us
	MOVWF DS1820_2_HELP
	BCF STATUS,CARRY
DS1820_2_RESET_2
	; wait
	BTFSS DS1820_2_IO
	BSF STATUS,CARRY

	DECFSZ DS1820_2_HELP,F
	GOTO DS1820_2_RESET_2
	RETURN
